/* Copyright 2009 Marcel Overdijk
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.grails.samples.sakila

abstract class BaseController {

    private restoreState(stateParams) {
        // get (or initialize) session state params
        def sessionStateParams = session["${controllerName}Controller"] = (session["${controllerName}Controller"] ?: [:])
        // store state params and its values in params and session object
        // (1) use params (2) or use session (3) otherwise use default value
        stateParams.each { k, v ->
            if (params[k] == "") {
                params[k] = sessionStateParams[k] = v
            }
            else {
                params[k] = sessionStateParams[k] = (params[k] ?: (sessionStateParams[k] ?: v))
            }
        }

    }

    private restoreState(key, stateParams) {
        // get (or initialize) session state params
        def sessionStateParams = session["${controllerName}Controller.${key}"] = (session["${controllerName}Controller.${key}"] ?: [:])
        // store state params and its values in params and session object
        // (1) use params (2) or use session (3) otherwise use default value
        stateParams.each { k, v ->
            if (params[k] == "") {
                params[k] = sessionStateParams[k] = v
            }
            else {
                params[k] = sessionStateParams[k] = (params[k] ?: (sessionStateParams[k] ?: v))
            }
        }
    }
}
