/* Copyright 2009 Marcel Overdijk
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.grails.samples.sakila

class Store {

    static hasMany = [staff: Staff]

    Staff manager
    Address address

    static constraints = {
        manager(nullable: false)
        address(nullable: false)
    }

    static mapping = {
        id column: "store_id"
        manager column: "manager_staff_id"
        sort id: "asc"
        version false
    }

    String toString() { id }
}
